<?php
include_once('../common/delegate.php');
// Start the session
session_start();

// Check if user is logged
if(!is_numeric($_SESSION['userId'])) {
	header("Location: ". SERVER_ROOT ."");
	exit();
}

// Make new Delegate instance
$delegate = new Delegate();

// Load user as object, from SQL by id
$loggedUser = $delegate->getUserById($_SESSION['userId']);

// If logged user is admin, get all projects
if($loggedUser->level >= USER_LEVEL_ADMIN) {
	$projects = $delegate->getProjects();

// If logged user isn't admin, get only him projects
} else {
	$userInProjects = $delegate->getUsersInProjects(array("userid" => $loggedUser->id));
	
	if(count($userInProjects) > 0) {
	
		foreach($userInProjects as $userInProjectKey => $userInProject) {
			$x  = $delegate->getProjects(array("id" => $userInProject->projectId));
			$projects[] = $x[0]; 
		}
		
	} else {
		$projects = array();
	}
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Projects and Tasks</title>
        <link rel="shortcut icon" href="<?=SERVER_ROOT?>/pontaj.ico" type="image/x-icon" />
        <link href="<?=SERVER_ROOT?>/assets/css/pontaj.css" rel="stylesheet" type="text/css" />        
        <script type="text/javascript" src="<?=SERVER_ROOT?>/assets/javascript/general.js"></script>        
    </head>
    
    <body>
		<?php
			define('SECTION', 'projects');
			include_once("../common/header.php");
			include_once("../common/mainbar.php");
			print showErrorAndMessagesLogs();

################################################################################
// If logged user is admin or super admin

if($loggedUser->level >= USER_LEVEL_ADMIN) { ?>
	<!-- START: Add a new project -->
	<div class="page_title">Add new project</div> 
		<form action="<?=SERVER_ROOT?>/common/controller.php" method="POST" id="addProjectForm" style="display:inline" accept-charset="utf-8">
			<table cellpadding="0" cellspacing="3" class="form_style">
                
				<tr>
					<th><label for="name">Project name</label></th>
					<td>(<span class="required_field" title="Mandatory field">*</span>)</td>
					<td><input style="width:209px;" type="text" name="name" id="name" /></td>
				</tr>

				<tr>
					<th><label for="clientId">Client</label></th>
					<td>&nbsp;</td>
					<td>
						<select name="clientId" id="clientId">
							<option value="NULL">-- none --</option>
							<?php
								$clients = $delegate->getClients(false, false, false, 'client_name ASC');
								if(count($clients) > 0) {
									foreach($clients as $clientKey => $client) { ?>
										<option value="<?=$client->id?>"><?=$client->name?></option>
							<?php
									}
								}
							?>
						</select>
					</td>
				</tr>
                    
				<tr>
					<th>Add me in this project</th>                           
					<td>&nbsp;</td>
					<td>
						<input type="checkbox" name="includeInProject" checked="checked" />
					</td>    
				</tr>    
                        
				<tr>
					<th>&nbsp;</th>
					<td>&nbsp;</td>
					<td align="right">
						<input type="hidden" name="action" value="doAddProjectExe" />
						<!--<input type="submit" class="submit_button" style="width:150px" value="Add project" />-->
                        <button type="submit" class="submit_button" style="width:120px;cursor:pointer"><img src="<?=SERVER_ROOT?>/assets/images/icons/project_add.gif" style="vertical-align:middle;" /> &nbsp;Add project</button>       
					</td>
				</tr>
                    
				<tr>
					<td class="required_field_info"><span class="required_field" title="Mandatory field">*</span>&nbsp;mandatory field</td>
				</tr>
                    
			</table>    
		</form>
	<br/>
	<hr/>
	<!-- END: add a new project -->
<?
} // End if
################################################################################


// Display Adauga pontaj form only if user is assigned to projects
// Or if user is admin
if(count($projects) > 0 OR $loggedUser->level >= USER_LEVEL_ADMIN) { ?>
	<div class="page_title">Projects</div>  
	<?php
		if(count($projects) > 0) { ?>
		<table cellpadding="7" cellspacing="0" class="list_something">
		 
			<!-- START: Table headers -->
			<tr>
				<th>Projects</th>
                <th>Current</th>                
				<?if($loggedUser->level >= USER_LEVEL_ADMIN){?><th colspan="1">Edit</th> <? } ?>				
				<?if($loggedUser->level >= USER_LEVEL_ADMIN){?><th colspan="1">Open/Close</th> <? } ?>
				<?if($loggedUser->level >= USER_LEVEL_ADMIN){?><th>Client</th> <? } ?>
                 <?if($loggedUser->level >= USER_LEVEL_ADMIN){?><th colspan="1">Delete</th> <? } ?>
				<th colspan="<?=($loggedUser->level >= USER_LEVEL_ADMIN) ? '6' : '2'?>">&nbsp;</th>
			</tr>     
			<!-- END: Table headers -->

			<?php
				foreach($projects as $projectKey => $project) {
					// List only active projects for a normal user
					// But for admin list all
					/* START: IF 5 */
					if ($loggedUser->level >= USER_LEVEL_ADMIN || ($project->status == PROJECT_STATUS_OPEN)) { ?>
            			<tr class="<?=($loggedUser->defaultProject == $project->id) ? "project_current" : "project_line" ?>">
            				<td><?=$project->name?><?/*($loggedUser->defaultProject == $project->id) ? "*" : "" */?></td>
                            <td>
                                <?php
                                    // User default project is this one OR
                                    // User is not in this project
                                    if($loggedUser->defaultProject == $project->id AND $delegate->checkUserInProject($loggedUser->id, $project->id) != 0) { ?>
                                        <img src="<?=SERVER_ROOT?>/assets/images/icons/project_current_active.gif" border="0" alt="Current project" title="Current project" />
                                <?  } else {
                                        if ($project->status == PROJECT_STATUS_OPEN) { ?>
                                            <a href="<?=SERVER_ROOT?>/common/controller.php?action=doSetCurrentProjectExe&amp;projectId=<?=$project->id?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/project_current_inactive.gif" border="0" alt="Set current" title="Set current" /></a>
                                <?php
                                        } else {
                                            print "-";
                                        }
                                    }
                                ?>
                            </td>
                            
            				<? if($loggedUser->level >= USER_LEVEL_ADMIN) { ?><td><a href="<?=SERVER_ROOT?>/common/controller.php?action=goToEditProject&amp;projectId=<?=$project->id?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/project_edit.gif" border="0" alt="Edit" title="Edit" /></a></td> <?}?>
            				<? if($loggedUser->level >= USER_LEVEL_ADMIN) { ?>
                    				<td>
                    					<? if ($project->status == PROJECT_STATUS_CLOSE) { ?>
                    						<a onclick="javascript:return confirm('Are you sure you want to open this project?');"  href="<?=SERVER_ROOT?>/common/controller.php?action=doChangeProjectStatusExe&amp;projectId=<?=$project->id?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/project_close.gif" border="0" alt="Open" title="Open" /></a>
                    					<? } else { ?>
                    						<a onclick="javascript:return confirm('Are you sure you want to close this project?');"  href="<?=SERVER_ROOT?>/common/controller.php?action=doChangeProjectStatusExe&amp;projectId=<?=$project->id?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/project_open.gif" border="0" alt="Close" title="Close" /></a>
                    					<? } ?>    
                    				</td>
            				<? }
            				
            				// If logged user is admin or highter
            				if($loggedUser->level >= USER_LEVEL_ADMIN) {
            					if(is_numeric($project->clientId)) {
            						$client = $delegate->getClient(array("id" => $project->clientId));
            						print("<td>{$client->name}</td>");
            						
            					} else {
            						print("<td> - </td>");
            					}
            				}
                            ?>
                            
                            <? if($loggedUser->level >= USER_LEVEL_ADMIN) { ?><td><a onclick="javascript:return confirm('Are you sure you want to delete this project?\nAll tasks and entries from this project will also be deleted!');"  href="<?=SERVER_ROOT?>/common/controller.php?action=doDeleteProjectExe&amp;projectId=<?=$project->id?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/project_delete.gif" border="0" alt="Delete" title="Delete" /></a></td> <?}?>
                                
            				<?php
            					if ($project->status == PROJECT_STATUS_OPEN) { ?>
            						<td colspan="<?=$loggedUser->level >= USER_LEVEL_ADMIN ? '6' : '2'?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/tasks.gif" border="0" alt=""  />&nbsp;Tasks in project <b><?=$project->name?></b></td>
            				<?php
            					} else { ?>
            						<td colspan="<?=$loggedUser->level >= USER_LEVEL_ADMIN ? '6' : '2'?>"><b>&nbsp;</b></td>
            				<?php
            					}
            				?>
                            
            			</tr>


<!-- x -->

<?
						// Get all tasks for a project
                		$tasks = $delegate->getTasks(array("projectid" => $project->id, "__order" => "task_order ASC"));
                
	        	        // Only for open projects
                        /*
    		            if (($project->status == PROJECT_STATUS_OPEN) && (count($tasks) > 0)) { ?>
		                <tr>
        		            <td colspan="<?=$loggedUser->level >= USER_LEVEL_ADMIN ? '6' : '2' ?>">&nbsp;</td>
                		    <td class="column_name">Name</td>
                    		<?if($loggedUser->level >= USER_LEVEL_ADMIN){?><td class="column_name">Edit</td> <?}?>
                    		<?if($loggedUser->level >= USER_LEVEL_ADMIN){?><td class="column_name">Delete</td> <?}?>
                    		<td class="column_name">Set current</td>
                    		<?if($loggedUser->level >= USER_LEVEL_ADMIN){?><td class="column_name">Order</td> <?}?>
                		</tr>
                		<?
                		}*/
                
				// Ony for open projects
				if($project->status == PROJECT_STATUS_OPEN) { ?>
					<!-- START: Display tasks -->
				<?
					if(count($tasks) > 0) {
						foreach($tasks as $taskKey => $task) { ?>
							<tr>
								<td colspan="<?=$loggedUser->level >= USER_LEVEL_ADMIN ? '6' : '2' ?>" class="no_style">&nbsp;</td>
								<td><?=$task->name?><? /* ($loggedUser->defaultTask == $task->id) ? "*" : "" */ ?></td>
                                <td>
                                    <?
                                        // Selected project OR user not in project
                                        if(($loggedUser->defaultTask == $task->id) AND $delegate->checkUserInProject($loggedUser->id, $project->id) != 0) { ?>
                                            <img src="<?=SERVER_ROOT?>/assets/images/icons/task_current_active.gif" border="0" alt="Current task" title="Current task" />
                                    <?  } else {    ?>
                                            <a href="<?=SERVER_ROOT?>/common/controller.php?action=doSetDefaultTaskExe&amp;taskId=<?=$task->id?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/task_current_inactive.gif" border="0" alt="Set current" title="Set current" /></a>
                                    <?  }   ?>
                                </td>
								<?if ($loggedUser->level >= USER_LEVEL_ADMIN) {?><td><a href="<?=SERVER_ROOT?>/common/controller.php?action=goToEditTask&amp;taskId=<?=$task->id?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/task_edit.gif" border="0" alt="Edit" title="Edit" /></a></td> <? } ?>
								<?if ($loggedUser->level >= USER_LEVEL_ADMIN) {?><td><a onclick="javascript:return confirm('Are you sure you want to delete this task?\nAll entries from this task will also be deleted!');" href="<?=SERVER_ROOT?>/common/controller.php?action=doDeleteTaskByIdExe&amp;taskId=<?=$task->id?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/task_delete.gif" border="0" alt="Delete" title="Delete" /></a></td> <?}?>
								

								<?	if ($loggedUser->level >= USER_LEVEL_ADMIN) { ?>									
									<td>
									<?	if($task->order > 1) { ?>
											<a href="<?=SERVER_ROOT?>/common/controller.php?action=doMoveTaskExe&amp;direction=up&amp;taskId=<?=$task->id?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/move_up.gif" border="0" alt="Move up" title="Move up" /></a>
									<?	}
									
										if($task->order > 1 AND $task->order < count($tasks)) {
											print "/";
										}
										
										if($task->order < count($tasks)) { ?>
											<a href="<?=SERVER_ROOT?>/common/controller.php?action=doMoveTaskExe&amp;direction=down&amp;taskId=<?=$task->id?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/move_down.gif" border="0" alt="Move down" title="Move down" /></a>
									<?	}	?>
									</td>    
								<?	}	?>

        	                  </tr>
						<?	} /* END: foreach($tasks as $taskKey => $task) */
							} else {
								print "<!-- no tasks -->";
							}?>
                        <!-- END: Display tasks -->
                        

                        <!-- START: Add new task -->
                        <?
                        	if($loggedUser->level >= USER_LEVEL_ADMIN) { ?>
                        <tr>
                            <td colspan="6" class="no_style">&nbsp;</td>
                            <td colspan="6">
                                <form action="<?=SERVER_ROOT?>/common/controller.php" method="post">
                                    <table cellpadding="0" cellspacing="0" class="form_style" style="width:420px;border-style:none;">
                                        <tr>
                                            <td style="border-style:none;"><label>Task</label></td>
                                            <td style="border-style:none;">(<span class="required_field" title="Mandatory field">*</span>)</td>
                                            <td style="border-style:none;"><input type="text" name="taskName">
                                                <input type="hidden" name="action" value="doAddTaskExe">
                                                <input type="hidden" name="projectId" value="<?=$project->id?>">
                                                <!--<input type="submit" class="submit_button" value="Add task">-->
                                                <button type="submit" class="submit_button" style="width:100px;cursor:pointer"><img src="<?=SERVER_ROOT?>/assets/images/icons/task_add.gif" style="vertical-align:middle;" /> &nbsp;Add task</button>       
                                            </td>
                                        </tr>
                                    </table>    
                                </form>
                            </td>
                        </tr>
                        <?
                        	} /* end if */ ?>
                        <!-- END: Add new task-->
                     <?}?>
                <? /*------------ end ACTIVITATI ---------------*/ ?>
                
                

<?	############################################################################
	/*--------------------------- start USERs --------------------------*/     
                
	// Get all users in project
	$usersInProjects = $delegate->getUsersInProjects(array("projectid" => $project->id));
                
	// Only admin can see all users in project and manage them
	if ($loggedUser->level >= USER_LEVEL_ADMIN && ($project->status == PROJECT_STATUS_OPEN)) { ?>
		<tr>
			<td style="border-top-style:none" colspan="<?=($loggedUser->level >= USER_LEVEL_ADMIN) ? '6' : '2'?>">&nbsp;</td>
			<td <?=($user->defaultProject == $project->id)?"class=\"project_current\"":"class=\"project_line\""?> colspan="<?=($loggedUser->level >= USER_LEVEL_ADMIN) ? '6' : '2'?>"><img src="<?=SERVER_ROOT?>/assets/images/icons/users_3.gif" border="0" alt=""  />&nbsp; Users in project <b><?=$project->name?></b></td>
		</tr>

		<?/*
			if(($project->status == PROJECT_STATUS_OPEN) AND (is_array($usersInProjects))) { ?>
		<tr>
			<td style="border-top-style:none" colspan="<?=$loggedUser->level >= USER_LEVEL_ADMIN ? '6' : '2'?>">&nbsp;</td>
			<td class="column_name">Name</td>
			<td class="column_name">Email</td>
			<td class="column_name" colspan="3" align="center">Delete</td>
		</tr>
		<?
			}	*/
         ?>

		<!-- Display users -->
		<?	
			if(count($usersInProjects) > 0) {
				foreach($usersInProjects as $userInProjectKey => $userInProject) {
					$diplayUser = $delegate->getUserById($userInProject->userId);
		?>
		<tr>
			<td colspan="<?=$loggedUser->level >= USER_LEVEL_ADMIN ? '6' : '2'?>" class="no_style">&nbsp;</td>
			<td><?=$diplayUser->name?></td>
			<td><?=$diplayUser->email?></td>
			<td colspan="3" align="center"><a onclick="javascript:return confirm('Are you sure you want to delete this user from this task / project?');" href="<?=SERVER_ROOT?>/common/controller.php?action=doDelteUserFromProjectExe&amp;userId=<?=$diplayUser->id?>&amp;projectId=<?=$project->id?>" ><img src="<?=SERVER_ROOT?>/assets/images/icons/user_delete.gif" border="0" alt="Delete" title="Delete" /></a></td>
		</tr>
		<?
				} // End foreach
			} // End if
		?>
		<!-- End Display users -->

		<!-- START: Add new user -->
<?
	if($loggedUser->level >= USER_LEVEL_ADMIN) { ?>
	<tr>
		<td colspan="6" class="no_style">&nbsp;</td>
		<td colspan="6">
			<form action="<?=SERVER_ROOT?>/common/controller.php" method="post">
				<table cellpadding="0" cellspacing="0" class="form_style" style="width:420px;border-style:none;">
					<tr>
						<td style="border-style:none;"><label>User</label></td>
						<td style="border-style:none;">(<span class="required_field" title="Mandatory field">*</span>)</td>
						<td style="border-style:none;">
							<select name="user">
								<option value="0">-- select an user --</option>
						<?
							$allUsers = $delegate->getUsers(array('__order' => 'user_name ASC'));
                            
                            // list only users that are not already in project                        
							foreach($allUsers as $allUserKey => $allUser) {
								if ($delegate->checkUserInProject($allUser->id, $project->id) == 0) { ?>
									<option value="<?=$allUser->id?>"><?=$allUser->name ." (". $allUser->email .")"?></option>
						<?
								}     
							}
						?>    
							</select>

							<input type="hidden" name="action" value="doAddUserInProjectExe">
							<input type="hidden" name="projectId" value="<?=$project->id?>">
							<!--<input type="submit" class="submit_button" style="width:100px"  value="Add user">-->
                            <button type="submit" class="submit_button" style="width:100px;cursor:pointer"><img src="<?=SERVER_ROOT?>/assets/images/icons/user_add.gif" style="vertical-align:middle;" /> &nbsp;Add user</button>       
						</td>
					</tr>
				</table>
			</form>
		</td>
	</tr>
<?
	} //end if
?>
	<!-- END: Add new user -->
                    
<?
	} // if admin & active project
	
	/*--------------------------- end USERS --------------------------*/
	############################################################################	?>
                     
                     
                     
                <?}//end if active projects
                }//end for projects
                ?>
                </table>
                
            <br /><br />
            
            <table cellpadding="7" cellspacing="0" class="list_something">
            	<tr>
            		<th colspan="4" align="left">Legend</th>
            	</tr>
            	
<? if($loggedUser->level >= USER_LEVEL_ADMIN) { ?>                       
                <tr>
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/project_add.gif" /></td>
                    <td align="left">add project </td>
                    
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/task_edit.gif" /></td>
                    <td align="left">edit task</td>
            	</tr>
            	
                <tr>
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/project_current_inactive.gif" /></td>
                    <td align="left">project not set as current</td>

                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/task_current_active.gif" /></td>
                    <td align="left">task set as current</td>
                </tr>
                        
            	<tr>
            		<td><img src="<?=SERVER_ROOT?>/assets/images/icons/project_current_active.gif" /></td>
                    <td align="left">project set as current</td>
           
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/task_current_inactive.gif" /></td>
                    <td align="left">task not set as current</td>
            	</tr>
            	
            	<tr>
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/project_open.gif" /></td>
                    <td align="left">opened project</td>
                    
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/task_delete.gif" /></td>
                    <td align="left">delete task</td>
                </tr>
            	
                <tr>
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/project_close.gif" /></td>
                    <td align="left">closed project</td>
                    
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/move_up.gif" /></td>
                    <td align="left">reorder task in project (move up one level)</td>
            	</tr>
            	
            	<tr>
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/project_edit.gif" /></td>
                    <td align="left">edit project</td>
                    
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/move_down.gif" /></td>
                    <td align="left">reorder task in project (move down one level)</td>
                </tr>
                
                <tr>
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/project_delete.gif" /></td>
                    <td align="left">delete project</td>
                    
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/users_3.gif" /></td>
                    <td align="left">all users in project</td>
            	</tr>
            	
            	<tr>
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/tasks.gif" /></td>
                    <td align="left">all tasks in project</td>
                     
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/user_add.gif" /></td>
                    <td align="left">add user</td>   
                </tr>
                
                <tr>
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/task_add.gif" /></td>
                    <td align="left">add task</td>
                    
                   <td><img src="<?=SERVER_ROOT?>/assets/images/icons/user_delete.gif" /></td>
                   <td align="left">remove user from project</td>
                </tr>
<?	} else { ?>
                <tr>
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/project_current_inactive.gif" /></td>
                    <td align="left">project not set as current</td>
				</tr>
				
				<tr>
				    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/project_current_active.gif" /></td>
                    <td align="left">project set as current</td>
                </tr>

				<tr>
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/tasks.gif" /></td>
                    <td align="left">all tasks in project</td>
                </tr>
				
                <tr>
                    <td><img src="<?=SERVER_ROOT?>/assets/images/icons/task_current_active.gif" /></td>
                    <td align="left">task set as current</td>
                </tr>
                
                <tr>
                	<td><img src="<?=SERVER_ROOT?>/assets/images/icons/task_current_inactive.gif" /></td>
                    <td align="left">task not set as current</td>
                </tr>
<?	} ?>
            </table>
            
            <?}else{
                 void();       
          		}?>  
        <?}else{?>
            <div class="no_assigned_project_msg">
                You are not assigned to any project!<br/>
                <?php
                if($loggedUser->level < USER_LEVEL_ADMIN) { 
                	echo 'Please contact your administrator to be added to a project!';
                } ?>
            </div>
        <?}?>   
        <br/>   




		<!-- FOOTER -->
        <?include_once("../common/footer.php");?>
        
    </body>
</html>