<?php
include_once('../common/delegate.php');
include_once('../common/calendar.php');

// Start the session
session_start();

// Check if user is logged
if(!is_numeric($_SESSION['userId'])) {
	header("Location: ". SERVER_ROOT ."");
	exit();
}

if(!empty($_GET['print']) AND $_GET['print'] == true AND !empty($_GET['clientId']) AND !empty($_GET['startDate']) AND !empty($_GET['endDate'])) {
	$print		=	true;
	$clientId	=	$_GET['clientId'];
	$projectId	=	$_GET['projectId'];
	$startDate	=	$_GET['startDate'];
	$endDate	=	$_GET['endDate'];
	
} else {
	$print = false;
}

if( !empty($_SESSION['clientReports']['clientId']) AND !empty($_SESSION['clientReports']['startDate']) AND !empty($_SESSION['clientReports']['endDate']) ) {
	$clientId	=	$_SESSION['clientReports']['clientId'];
	$projectId	=	$_SESSION['clientReports']['projectId'];
	$startDate	=	$_SESSION['clientReports']['startDate'];
	$endDate	=	$_SESSION['clientReports']['endDate'];
	
	unset($_SESSION['clientReports']);
}

// Make new Delegate instance
$delegate = new Delegate();

// Load user as object, from SQL by id
$loggedUser = $delegate->getUserById($_SESSION['userId']);

// Check if logged user is admin
if($loggedUser->level < USER_LEVEL_ADMIN) {
	header("Location: ". SERVER_ROOT ."/daily/daily.php");
	exit();
}


if(is_object($_SESSION['tmpClientReports'])) {
	$tmpClientReports = $_SESSION['tmpClientReports'];
	$_SESSION['tmpClientReports'] = null;
	unset($_SESSION['tmpClientReports']);
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

        
        <meta http-equiv="pragma" content="no-cache" />
        <meta http-equiv="expires" content="0">
        <title>Client reports</title>
        <link rel="shortcut icon" href="<?=SERVER_ROOT?>/pontaj.ico" type="image/x-icon" />

        <?	if($print == true) { ?>
        	<link href="<?=SERVER_ROOT?>/assets/css/print.css" rel="stylesheet" type="text/css" />
        <?	} else { ?>
        	<link href="<?=SERVER_ROOT?>/assets/css/pontaj.css" rel="stylesheet" type="text/css" />
        <?	}	?>
        
        <link href="<?=SERVER_ROOT?>/assets/calendar/calendar-win2k-1.css" rel="stylesheet" type="text/css" />
        <script type="text/javascript" src="<?=SERVER_ROOT?>/assets/calendar/calendar.js"></script>
        <script type="text/javascript" src="<?=SERVER_ROOT?>/assets/calendar/lang/calendar-en.js"></script>

        <script type="text/javascript" src="<?=SERVER_ROOT?>/assets/calendar/calendar-setup.js"></script>
        <script type="text/javascript" src="<?=SERVER_ROOT?>/assets/javascript/general.js"></script>     
        <script language="JavaScript" type="text/javascript">            
            function pickPeriod() {
                
                var period = document.getElementById('period');
                var periodStart = document.getElementById('periodStart');
                var periodEnd = document.getElementById('periodEnd');
                switch(period.value) {
                    
                    case 'currentMonth':
                        var date = new Date()
                        date.setDate(1)
                        periodStart.value = date.getDate() + '/' + (date.getMonth() +1) + '/' + date.getFullYear()
                        
                        date.setMonth(date.getMonth() + 1)
                        date.setDate(date.getDate() - 1)
                        periodEnd.value = date.getDate() + '/' + (date.getMonth() +1) + '/' + date.getFullYear()
                        break;
                        
                    case 'lastMonth':
                        var date = new Date();
                        date.setDate(1)
                        date.setMonth(date.getMonth() - 1)
                        periodStart.value = date.getDate() + '/' + (date.getMonth() +1) + '/' + date.getFullYear()
                        
                        date.setMonth(date.getMonth() + 1)
                        date.setDate(date.getDate() - 1)
                        periodEnd.value = date.getDate() + '/' + (date.getMonth() +1) + '/' + date.getFullYear()
                        break;
                }
            }
        </script>
        <script language="JavaScript1.5" src="<?=SERVER_ROOT?>/assets/javascript/json2.js" type="text/javascript"></script>
        <script language="JavaScript" type="text/javascript">            
            
            var http = null;            
            http = getHTTPObject();
            
            /*
            You can not reuse the XMLHttpRequest in IE6. 
            To do that you have to use abort() method.
            See: 
                http://radio.javaranch.com/pascarello/2006/03/30/1143735438047.html
                http://keelypavan.blogspot.com/2006/03/reusing-xmlhttprequest-object-in-ie.html
                http://blogs.pathf.com/agileajax/2006/08/object_pooling_.html
                http://ajaxian.com/archives/reusing-xmlhttprequest-without-abort
                http://en.wikipedia.org/wiki/XMLHttpRequest
            */
            function getHTTPObject() {
                if(http == null){
                    //alert('Is null');
                    if (window.XMLHttpRequest) { // Mozilla, Safari,...

                        http = new XMLHttpRequest();
                        if (http.overrideMimeType) {
                            http.overrideMimeType('text/html');
                            //netscape.security.PrivilegeManager.enablePrivilege("UniversalPreferencesRead");
                        }
                    } else if (window.ActiveXObject) { // IE
                        try {
                            http = new ActiveXObject("Msxml2.XMLHTTP");
                        } catch (i) {
                            try {
                                http = new ActiveXObject("Microsoft.XMLHTTP");
                            } catch (i) {}
                        }
                    }
                    
                } else{
                    //alert('Is NOT null');
                    http.abort()
                }
                return http;                
            }
            
            function debugObject(obj){
                for(var prop in obj){
                    alert(prop);
                    for(var subprop in obj[prop]){
                        alert(subprop);
                    }
                }
            }
            
            function callProjects(){
                http = getHTTPObject();
                //alert('k');
                var url = '<?=SERVER_ROOT?>/common/projectsForClient.php?'
                
                //get selected client
                if (document.getElementById('clientId')){
                    var clientSelect = document.getElementById('clientId');
                    var clientId = clientSelect.options[clientSelect.selectedIndex].value;
                    //alert(' Client is ' + clientSelect.options[clientSelect.selectedIndex].value);

                    var params = 'clientId='+ clientId;

                    http.open("POST", url, true);
                    http.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded'); 
                    http.onreadystatechange = function() {
                        if (http.readyState == 4 && http.status == 200) {
                            var result = http.responseText;
                            //alert(result);
                            http.abort();


                            //clear project select
                            var projectSelect = document.getElementById('projectId');
                            projectSelect.options.length = 0;

                            //populate the project select
                            var myObject = JSON.parse(result, null);
                            //debugObject(myObject['projects']);
                            //alert(myObject["projects"].length);

                            projectSelect.options[0] = new Option('All projects', 'NULL');
                            var i = 1;
                            for(var k=0; k<myObject['projects'].length; k++){
                                //alert(myObject.projects[k]['name']);
                                projectSelect.options[i] = new Option(myObject.projects[k]['name'], myObject.projects[k]['id']);
                                i++;
                            }
                        }
                        else {
                            //alert('Cannot access cross domain information.' + http);
                        }
                    }
                    //alert(params);
                    http.send(params);	
                }//if
           }
    </script>
    
    </head>
    <body onload="callProjects()">
		<?php
			define('SECTION', 'reports');
			include_once("../common/header.php");
			include_once("../common/mainbar.php");
			print showErrorAndMessagesLogs();
		?>
        

<div class="current_date">Current date: &nbsp; <b><?=getDateAndTime()?></b><?=(!empty($clientId) AND !empty($startDate) AND !empty($startDate)) ? '| <a href="'. SERVER_ROOT .'/reports/client-reports.php?print=true&amp;clientId='. $clientId .'&amp;projectId='. $projectId .'&amp;startDate='. $startDate .'&amp;endDate='. $endDate .'" target="_blank" class="print_version"><img src="'. SERVER_ROOT .'/assets/images/print2.jpg" border="0" alt="Print this report" title="Print this report">Print this report</a>' : "" ?></div>
<hr />

<?php if($print ==  false) { ?>
        <div class="page_title">Client reports</div> 
        
        <form action="<?=SERVER_ROOT?>/common/controller.php" method="POST">
            <input type="hidden" name="action" value="doDisplayClientReportExe"/>
            <table cellpadding="0" cellspacing="3" class="form_style">
                <tr>

                    <th><label for="client">Client</label></th>
                     <td>(<span class="required_field" title="Mandatory field">*</span>)</td>
                    <td>
                        <select id="clientId" name="clientId" onchange="callProjects()">
                            <option value="NULL" selected="selected">Select a client</option>
                            <?
                            	$clients = $delegate->getClients();
                            	if(count($clients) > 0) {
                            		foreach($clients as $clientKey => $client) {
                            			?>
                            			<option value="<?=$client->id?>" <?=($tmpClientReports->clientId == $client->id) ? 'selected="selected"' : void()?>><?=$client->name?></option>
                            			<?
                            		}	
                            	}
                            ?>
                        </select>
                    </td>
                </tr>
                <tr>
                    <th><label for="project">Project</label></th>
                    <td>&nbsp;</td>
                    <td>

                        <select id="projectId" name="projectId" >
                            <option value="0">Select a project</option>
                        </select>
                    </td>
                <tr>
                <tr>
                    <th><label for="period">Period of time</label></th>
                    <td>(<span class="required_field" title="Mandatory field">*</span>)</td>

                    <td>
                        <select id="period" name="period" onchange="pickPeriod()">
                            <option value="0">Select period of time</option>
                            
                            <option value="currentMonth">Current month</option>
                            <option value="lastMonth">Last month</option>
                        </select>
                    </td> 
                </tr> 
                
                <tr>

                    <th><label for="periodStart">Start date<br/><span class="date_format_tip">[dd/mm/yyyy]</span></label></th>
                    <td>&nbsp;</td>
                    <td>
                        <input style="width:211px;" type="text" name="periodStart" id="periodStart" value="<?=$tmpClientReports->startDate?>">
                    </td>
                    <td>           
                        <input type="image" src="../assets/calendar/img.gif" id="periodStartTrigger">
                        <?=calendarSetup('periodStart', '%d/%m/%Y', 24, 'false', 'periodStartTrigger', 'false', 1)?>
                    </td> 
                </tr> 
                
                <tr>
                    <th><label for="periodEnd">End date<br/><span class="date_format_tip">[dd/mm/yyyy]</span></label></th>
                    <td>&nbsp;</td>
                    <td>
                        <input style="width:211px;" type="text" name="periodEnd" id="periodEnd" value="<?=$tmpClientReports->endDate?>">
                    </td>
                    <td>                             
                        <input type="image" src="../assets/calendar/img.gif" id="periodEndTrigger">
						<?=calendarSetup('periodEnd', '%d/%m/%Y', 24, 'false', 'periodEndTrigger', 'false', 1)?>   
                    </td> 
               </tr> 
               
              <tr>
                <td>&nbsp;</td>
                <td>&nbsp;</td>
                <td align="right">
                    <a href="<?=SERVER_ROOT?>/common/controller.php?action=goToReports" class="cancel_action">Cancel</a>
                    <input type="submit" value="Submit" class="submit_button">

                </td>
                <td>&nbsp;</td>
             </tr>
             
             <tr>
                <td class="required_field_info"><span class="required_field" title="Mandatory field">*</span>&nbsp;mandatory field</td>
             </tr>
             
           </table>
        </form>
<? }


if(is_numeric($clientId) AND !empty($startDate) AND !empty($endDate)) {
	
	// Get client by id
	$clients		=	$delegate->getClients($clientId);
	if(count($clients) == 1) {
		foreach($clients as $clientKey => $client);
		if(is_numeric($projectId) AND $projectId > 0) {
			$projects = $delegate->getProjects(array("id" => $projectId, "clientid" => $client->id));
		} else {
			$projects = $delegate->getProjects(array("clientid" => $client->id));
		}	
	}
	
	
	
	$intStartDate	=	strtotime($startDate);
	$intEndDate		=	strtotime($endDate);
	
	$daysNo = (($intEndDate-$intStartDate)/86400+1);
?>
	<div class="page_title">Project reports (<?=date("M d, Y", strtotime($startDate))?> - <?=date("M d, Y", strtotime($endDate))?>)</div>
	<div class="page_title" style="font-size:14px;">Client: <?=$client->name?></div>

	<table cellpadding="10" cellspacing="0" class="list_something">
	            
		<tr>
			<th rowspan="2">Date</th>
			<th colspan="<?=count($projects)?>">Projects</th>
			<th rowspan="2">Total hours<br />for each day</th>
		</tr>
			
		<tr>
			<?
			if(count($projects) > 0) {
				foreach($projects as $projectKey => $project) {
					print "<th>{$project->name}</th>\n";
				}
			} else {
				print "<th>&nbsp;<th>";
			}
			?>
		</tr>
		
		<?	
			$nextDayAndMonth = $intStartDate;
			for($i = 1; $i<= $daysNo; $i++) {
		?>
			<tr>
				<td><?=date("Y-m-d", $nextDayAndMonth)?></td>
				<?
					$projectTotalTimeSpanForThisDate = 0;
					
					foreach($projects as $projectKey => $project) {
						
						$timeSpan = $delegate->computeProjectTimeSpanByDate($project->id, date("Y-m-d", $nextDayAndMonth));
						 
						if(is_numeric($timeSpan) AND $timeSpan > 0) {
							print "<td>". date("H:i", mktime(0, $timeSpan, 0, 0, 0, 0)) ."</td>\n";
							$projectTotalTimeSpanForThisDate += $timeSpan; 
							
						} else {
							print "<td>&nbsp;</td>";
						}
					}					
				?>
				<td><b><?=date("H:i", mktime(0, $projectTotalTimeSpanForThisDate, 0, 0, 0, 0))?></b></td>
			</tr>
		<?
			$nextDayAndMonth = $nextDayAndMonth + 86400;
			}
		?>
			
            <tr>
                <th rowspan="2">Total hours for<br /> each project</th>
                <?	$totalTimeSpanForProject = 0;
                
                	foreach($projects as $projectKey => $project) {
                		
                		$totalTimeSpanForProject = $delegate->computeProjectTimeSpanByDates($project->id, date("Y-m-d", $intStartDate), date("Y-m-d", $intEndDate));
                		$totalTimeSpanForProjects += $totalTimeSpanForProject;
                		
                		if(is_numeric($totalTimeSpanForProject) AND $totalTimeSpanForProject > 0) {
							print "<td><b>". floor($totalTimeSpanForProject/60) .":";
									if (strlen($totalTimeSpanForProject%60) <= 1)  {
										 echo '0'.$totalTimeSpanForProject%60;
									} else {
										echo $totalTimeSpanForProject%60;
									}
							echo "</b></td>\n";
							
								
						} else {
							print "<td><b>00:00</b></th>\n";
						}
                	}
                ?>
                <th>Total hours for<br />project: <? print floor($totalTimeSpanForProjects/60) .":";
                			if(strlen($totalTimeSpanForProjects%60) <= 1) {
                				echo '0'.$totalTimeSpanForProjects%60;
                			} else {
                				echo $totalTimeSpanForProjects%60;
                			}
                		?></th>
			</tr>
		
	</table>
<?

}
        

if($print == false) { ?>
		<!-- FOOTER -->
        <?include_once("../common/footer.php");?>
        
<? } ?>
    </body>
</html>